/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of GMP.xs. Do not edit this file, edit GMP.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "GMP.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "gmp.h"

/*
Math::GMP, a Perl module for high-speed arbitrary size integer
calculations
Copyright (C) 2000 James H. Turner

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

You can contact the author at chip@redhat.com, chipt@cpan.org, or by mail:

Chip Turner
Red Hat Inc.
2600 Meridian Park Blvd
Durham, NC 27713
*/

#define SWAP_GMP if (swap) { mpz_t* t = m; m = n; n = t; }

/*
 * mpz_rootrem() has bug with negative first argument before 5.1.0
 */
static int need_rootrem_workaround(mpz_t* m, unsigned long n) {
    /* workaround only valid for n odd (n even should be an error) */
    if ((n & 1) == 0)
        return 0;

    /* workaround only relevant for m negative */
    if (mpz_sgn(*m) >= 0)
        return 0;

    /* workaround only needed for gmp_version < 5.1.0 */
    if ((gmp_version[0] && gmp_version[1] != '.')            /* >= 10.0.0 */
        || (gmp_version[0] > '5')                            /* >=  6.0.0 */
        || (gmp_version[0] == '5' && gmp_version[2] != '0')  /* >=  5.1.0 */
    )
        return 0;

    return 1;
}

#if 0
static double
constant(char *name, int arg)
{
    errno = 0;
    switch (*name) {
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}
#endif

mpz_t *
pv2gmp(char* pv)
{
	mpz_t* z;
	SV* sv;

	z = malloc (sizeof(mpz_t));
	mpz_init_set_str(*z, pv, 0);
	sv = sv_newmortal();
	sv_setref_pv(sv, "Math::GMP", (void*)z);
	return z;
}

mpz_t *
sv2gmp(SV* sv)
{
	char* pv;

	/* MAYCHANGE in perlguts.pod - bug in perl */
	if (SvGMAGICAL(sv)) mg_get(sv);

	if (SvROK(sv) && sv_derived_from(sv, "Math::GMP")) {
		IV tmp = SvIV((SV*)SvRV(sv));
		return (mpz_t *)tmp;
	}

	pv = SvPV_nolen(sv);
	return pv2gmp(pv);
}


SV *
stringify(mpz_t *n)
{
    char *buf;
    char *pv;
    int len;
    SV *sv;

    len = mpz_sizeinbase(*n, 10);
    buf = malloc(len + 2);

    mpz_get_str(buf, 10, *n);
    sv = newSVpv(buf, strlen(buf));
    free(buf);
    return sv;
}


#line 132 "GMP.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 276 "GMP.c"

XS_EUPXS(XS_Math__GMP_new_from_scalar); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_new_from_scalar)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	char *	s = (char *)SvPV_nolen(ST(0))
;
	mpz_t *	RETVAL;
#line 130 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init_set_str(*RETVAL, s, 0);
#line 291 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_new_from_scalar_with_base); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_new_from_scalar_with_base)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "s, b");
    {
	char *	s = (char *)SvPV_nolen(ST(0))
;
	int	b = (int)SvIV(ST(1))
;
	mpz_t *	RETVAL;
#line 141 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init_set_str(*RETVAL, s, b);
#line 318 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "n");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
#line 151 "GMP.xs"
    mpz_clear(*n);
    free(n);
#line 342 "GMP.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__GMP__gmp_build_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP__gmp_build_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 157 "GMP.xs"
    char buf[] = STRINGIFY(__GNU_MP_VERSION)
        "." STRINGIFY(__GNU_MP_VERSION_MINOR)
        "." STRINGIFY(__GNU_MP_VERSION_PATCHLEVEL);
    RETVAL = newSV(6);
    scan_vstring(buf, buf + sizeof(buf), RETVAL);
#line 362 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP__gmp_lib_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP__gmp_lib_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 168 "GMP.xs"
    const char* v = gmp_version;
    RETVAL = newSV(6);
    scan_vstring(v, v + strlen(v), RETVAL);
#line 382 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_stringify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_stringify)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "n");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
	SV *	RETVAL;
#line 179 "GMP.xs"
    RETVAL = stringify(n);
#line 402 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_get_str_gmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_get_str_gmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "n, b");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
	int	b = (int)SvIV(ST(1))
;
#line 190 "GMP.xs"
    int len;

#line 424 "GMP.c"
	SV *	RETVAL;
#line 193 "GMP.xs"
    len = mpz_sizeinbase(*n, b);
    {
        char *buf;
        buf = malloc(len + 2);
        mpz_get_str(buf, b, *n);
        RETVAL = newSVpv(buf, strlen(buf));
        free(buf);
    }
#line 435 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_sizeinbase_gmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_sizeinbase_gmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "n, b");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
	int	b = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 210 "GMP.xs"
    RETVAL = mpz_sizeinbase(*n, b);
#line 458 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_uintify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_uintify)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "n");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
	unsigned long	RETVAL;
	dXSTARG;
#line 219 "GMP.xs"
    RETVAL = mpz_get_ui(*n);
#line 479 "GMP.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_add_ui_gmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_add_ui_gmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "n, v");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
	unsigned long	v = (unsigned long)SvUV(ST(1))
;
#line 229 "GMP.xs"
    mpz_add_ui(*n, *n, v);
#line 500 "GMP.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__GMP_intify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_intify)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "n");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
	long	RETVAL;
	dXSTARG;
#line 237 "GMP.xs"
    RETVAL = mpz_get_si(*n);
#line 519 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_mul_2exp_gmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_mul_2exp_gmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "n, e");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
	unsigned long	e = (unsigned long)SvUV(ST(1))
;
	mpz_t *	RETVAL;
#line 247 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_mul_2exp(*RETVAL, *n, e);
#line 543 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_div_2exp_gmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_div_2exp_gmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "n, e");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
	unsigned long	e = (unsigned long)SvUV(ST(1))
;
	mpz_t *	RETVAL;
#line 259 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_div_2exp(*RETVAL, *n, e);
#line 571 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_powm_gmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_powm_gmp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "n, exp, mod");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
	mpz_t *	exp = sv2gmp(ST(1))
;
	mpz_t *	mod = sv2gmp(ST(2))
;
	mpz_t *	RETVAL;
#line 273 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_powm(*RETVAL, *n, *exp, *mod);
#line 601 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_mmod_gmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_mmod_gmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpz_t *	a = sv2gmp(ST(0))
;
	mpz_t *	b = sv2gmp(ST(1))
;
	mpz_t *	RETVAL;
#line 286 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_mmod(*RETVAL, *a, *b);
#line 629 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_mod_2exp_gmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_mod_2exp_gmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "in, cnt");
    {
	mpz_t *	in = sv2gmp(ST(0))
;
	unsigned long	cnt = (unsigned long)SvUV(ST(1))
;
	mpz_t *	RETVAL;
#line 299 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_mod_2exp(*RETVAL, *in, cnt);
#line 657 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_op_stringify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_stringify)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	SV *	n = ST(1)
;
	bool	swap = (bool)SvTRUE(ST(2))
;
	SV *	RETVAL;
#line 313 "GMP.xs"
	/* 'n' and 'swap' are dummy variables */
	RETVAL = stringify(m);
#line 686 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_op_numify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_numify)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	SV *	n = ST(1)
;
	bool	swap = (bool)SvTRUE(ST(2))
;
	SV *	RETVAL;
#line 326 "GMP.xs"
	/* 'n' and 'swap' are dummy variables */
	if (mpz_sgn(*m) < 0) {
		RETVAL = newSViv(mpz_get_si(*m));
	} else {
		RETVAL = newSVuv(mpz_get_ui(*m));
	}
#line 715 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_op_bool); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_bool)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	SV *	n = ST(1)
;
	bool	swap = (bool)SvTRUE(ST(2))
;
	SV *	RETVAL;
#line 343 "GMP.xs"
	/* 'n' and 'swap' are dummy variables */
	RETVAL = mpz_sgn(*m) ? &PL_sv_yes : &PL_sv_no;
#line 740 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_op_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	bool	swap = (bool)SvTRUE(ST(2))
;
	mpz_t *	RETVAL;
#line 356 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_add(*RETVAL, *m, *n);
#line 766 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_op_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	bool	swap = (bool)SvTRUE(ST(2))
;
	mpz_t *	RETVAL;
#line 370 "GMP.xs"
    SWAP_GMP
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_sub(*RETVAL, *m, *n);
#line 797 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_op_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	bool	swap = (bool)SvTRUE(ST(2))
;
	mpz_t *	RETVAL;
#line 385 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_mul(*RETVAL, *m, *n);
#line 827 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_bmulf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_bmulf)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "n, d");
    {
	mpz_t *	n = sv2gmp(ST(0))
;
	double	d = (double)SvNV(ST(1))
;
#line 398 "GMP.xs"
    mpf_t nf, df;
    mp_bitcnt_t prec;
#line 853 "GMP.c"
	mpz_t *	RETVAL;
#line 401 "GMP.xs"
    /*
     Multiply (mpz_t) n by (double) d returning an (mpz_t) result.
     Uses GMP floats with maximum needed precision.
    */
    prec = mpf_get_default_prec();
    mpf_set_default_prec(mpz_sizeinbase(*n, 2) + 8 * sizeof(double));

    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpf_init(nf);
    mpf_init(df);

    mpf_set_z(nf, *n);
    mpf_set_d(df, d);
    mpf_mul(nf, nf, df);
    mpz_set_f(*RETVAL, nf);
    mpf_clear(nf);
    mpf_clear(df);
    /* restore default */
    mpf_set_default_prec(prec);
#line 876 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_op_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	bool	swap = (bool)SvTRUE(ST(2))
;
	mpz_t *	RETVAL;
#line 432 "GMP.xs"
    SWAP_GMP
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_div(*RETVAL, *m, *n);
#line 907 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_bdiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_bdiv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, n");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
#line 446 "GMP.xs"
    mpz_t * quo;
    mpz_t * rem;
#line 935 "GMP.c"
#line 449 "GMP.xs"
    quo = malloc (sizeof(mpz_t));
    rem = malloc (sizeof(mpz_t));
    mpz_init(*quo);
    mpz_init(*rem);
    mpz_tdiv_qr(*quo, *rem, *m, *n);
  EXTEND(SP, 2);
  PUSHs(sv_setref_pv(sv_newmortal(), "Math::GMP", (void*)quo));
  PUSHs(sv_setref_pv(sv_newmortal(), "Math::GMP", (void*)rem));
#line 945 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__GMP_op_mod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_mod)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	bool	swap = (bool)SvTRUE(ST(2))
;
	mpz_t *	RETVAL;
#line 467 "GMP.xs"
    SWAP_GMP
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_mod(*RETVAL, *m, *n);
#line 971 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_bmodinv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_bmodinv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, n");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	mpz_t *	RETVAL;
#line 480 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_invert(*RETVAL, *m, *n);
#line 999 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_op_spaceship); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_spaceship)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	bool	swap = (bool)SvTRUE(ST(2))
;
#line 494 "GMP.xs"
    int i;
#line 1026 "GMP.c"
	int	RETVAL;
	dXSTARG;
#line 496 "GMP.xs"
    i = mpz_cmp(*m, *n);
    if (swap) {
        i = -i;
    }
    RETVAL = (i < 0) ? -1 : (i > 0) ? 1 : 0;
#line 1035 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_op_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t*	m = sv2gmp(ST(0))
;
	mpz_t*	n = sv2gmp(ST(1))
;
	bool	swap = (bool)SvTRUE(ST(2))
;
#line 511 "GMP.xs"
    int i;
#line 1058 "GMP.c"
	int	RETVAL;
	dXSTARG;
#line 513 "GMP.xs"
    i = mpz_cmp(*m, *n);
    RETVAL = (i == 0) ? 1 : 0;
#line 1064 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_legendre); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_legendre)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, n");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 524 "GMP.xs"
    RETVAL = mpz_legendre(*m, *n);
#line 1087 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_jacobi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_jacobi)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, n");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 534 "GMP.xs"
    RETVAL = mpz_jacobi(*m, *n);
#line 1110 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_probab_prime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_probab_prime)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, reps");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	int	reps = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 544 "GMP.xs"
        RETVAL = mpz_probab_prime_p(*m, reps);
#line 1133 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_op_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_op_pow)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, n");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	long	n = (long)SvIV(ST(1))
;
	mpz_t *	RETVAL;
#line 554 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
/*    fprintf(stderr, "n is %ld\n", n);*/
    mpz_pow_ui(*RETVAL, *m, n);
#line 1158 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_bgcd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_bgcd)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, n");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	mpz_t *	RETVAL;
#line 568 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_gcd(*RETVAL, *m, *n);
#line 1186 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_blcm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_blcm)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, n");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	mpz_t *	RETVAL;
#line 581 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_lcm(*RETVAL, *m, *n);
#line 1214 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_fibonacci); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_fibonacci)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "n");
    {
	long	n = (long)SvIV(ST(0))
;
	mpz_t *	RETVAL;
#line 593 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_fib_ui(*RETVAL, n);
#line 1240 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_band); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_band)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "m, n, ...");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	mpz_t *	RETVAL;
#line 606 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_and(*RETVAL, *m, *n);
#line 1268 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_bxor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_bxor)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "m, n, ...");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	mpz_t *	RETVAL;
#line 618 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_xor(*RETVAL, *m, *n);
#line 1296 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_bior); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_bior)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "m, n, ...");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	mpz_t *	RETVAL;
#line 630 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_ior(*RETVAL, *m, *n);
#line 1324 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_blshift); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_blshift)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	bool	swap = (bool)SvTRUE(ST(2))
;
	mpz_t *	RETVAL;
#line 643 "GMP.xs"
    SWAP_GMP
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_mul_2exp(*RETVAL, *m, mpz_get_ui(*n));
#line 1355 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_brshift); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_brshift)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "m, n, swap");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	n = sv2gmp(ST(1))
;
	bool	swap = (bool)SvTRUE(ST(2))
;
	mpz_t *	RETVAL;
#line 657 "GMP.xs"
    SWAP_GMP
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_div_2exp(*RETVAL, *m, mpz_get_ui(*n));
#line 1386 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_bfac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_bfac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "n");
    {
	long	n = (long)SvIV(ST(0))
;
	mpz_t *	RETVAL;
#line 669 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_fac_ui(*RETVAL, n);
#line 1412 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_bnok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_bnok)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "n, k");
    {
	long	n = (long)SvIV(ST(0))
;
	long	k = (long)SvIV(ST(1))
;
	mpz_t *	RETVAL;
#line 682 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_bin_uiui(*RETVAL, n, k);
#line 1440 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_gmp_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_gmp_copy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "m");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	RETVAL;
#line 694 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init_set(*RETVAL, *m);
#line 1465 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_gmp_tstbit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_gmp_tstbit)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, n");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	long	n = (long)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 705 "GMP.xs"
    RETVAL = mpz_tstbit(*m,n);
#line 1492 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_broot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_broot)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, n");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	unsigned long	n = (unsigned long)SvUV(ST(1))
;
	mpz_t *	RETVAL;
#line 715 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_root(*RETVAL, *m, n);
#line 1516 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_brootrem); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_brootrem)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "m, n");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	unsigned long	n = (unsigned long)SvUV(ST(1))
;
#line 727 "GMP.xs"
    mpz_t * root;
    mpz_t * remainder;
#line 1544 "GMP.c"
#line 730 "GMP.xs"
    root = malloc (sizeof(mpz_t));
    remainder = malloc (sizeof(mpz_t));
    mpz_init(*root);
    mpz_init(*remainder);
    if (need_rootrem_workaround(m, n)) {
        /* Older libgmp have bugs for negative m, but if we need to we can
         * work on abs(m) then negate the results.
         */
        mpz_neg(*root, *m);
        mpz_rootrem(*root, *remainder, *root, n);
        mpz_neg(*root, *root);
        mpz_neg(*remainder, *remainder);
    } else {
        mpz_rootrem(*root, *remainder, *m, n);
    }
  EXTEND(SP, 2);
  PUSHs(sv_setref_pv(sv_newmortal(), "Math::GMP", (void*)root));
  PUSHs(sv_setref_pv(sv_newmortal(), "Math::GMP", (void*)remainder));
#line 1564 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__GMP_bsqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_bsqrt)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "m");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	mpz_t *	RETVAL;
#line 754 "GMP.xs"
    RETVAL = malloc (sizeof(mpz_t));
    mpz_init(*RETVAL);
    mpz_sqrt(*RETVAL, *m);
#line 1585 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::GMP", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_bsqrtrem); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_bsqrtrem)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "m");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *	m = sv2gmp(ST(0))
;
#line 765 "GMP.xs"
    mpz_t * sqrt;
    mpz_t * remainder;
#line 1611 "GMP.c"
#line 768 "GMP.xs"
    sqrt = malloc (sizeof(mpz_t));
    remainder = malloc (sizeof(mpz_t));
    mpz_init(*sqrt);
    mpz_init(*remainder);
    mpz_sqrtrem(*sqrt, *remainder, *m);
  EXTEND(SP, 2);
  PUSHs(sv_setref_pv(sv_newmortal(), "Math::GMP", (void*)sqrt));
  PUSHs(sv_setref_pv(sv_newmortal(), "Math::GMP", (void*)remainder));
#line 1621 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__GMP_is_perfect_power); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_is_perfect_power)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "m");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 782 "GMP.xs"
    RETVAL = mpz_perfect_power_p(*m) ? 1 : 0;
#line 1641 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__GMP_is_perfect_square); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__GMP_is_perfect_square)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "m");
    {
	mpz_t *	m = sv2gmp(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 791 "GMP.xs"
    RETVAL = mpz_perfect_square_p(*m) ? 1 : 0;
#line 1662 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Math__GMP); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__GMP)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Math::GMP::new_from_scalar", XS_Math__GMP_new_from_scalar, file, "$");
        (void)newXSproto_portable("Math::GMP::new_from_scalar_with_base", XS_Math__GMP_new_from_scalar_with_base, file, "$$");
        (void)newXSproto_portable("Math::GMP::destroy", XS_Math__GMP_destroy, file, "$");
        (void)newXSproto_portable("Math::GMP::_gmp_build_version", XS_Math__GMP__gmp_build_version, file, "");
        (void)newXSproto_portable("Math::GMP::_gmp_lib_version", XS_Math__GMP__gmp_lib_version, file, "");
        (void)newXSproto_portable("Math::GMP::stringify", XS_Math__GMP_stringify, file, "$");
        (void)newXSproto_portable("Math::GMP::get_str_gmp", XS_Math__GMP_get_str_gmp, file, "$$");
        (void)newXSproto_portable("Math::GMP::sizeinbase_gmp", XS_Math__GMP_sizeinbase_gmp, file, "$$");
        (void)newXSproto_portable("Math::GMP::uintify", XS_Math__GMP_uintify, file, "$");
        (void)newXSproto_portable("Math::GMP::add_ui_gmp", XS_Math__GMP_add_ui_gmp, file, "$$");
        (void)newXSproto_portable("Math::GMP::intify", XS_Math__GMP_intify, file, "$");
        (void)newXSproto_portable("Math::GMP::mul_2exp_gmp", XS_Math__GMP_mul_2exp_gmp, file, "$$");
        (void)newXSproto_portable("Math::GMP::div_2exp_gmp", XS_Math__GMP_div_2exp_gmp, file, "$$");
        (void)newXSproto_portable("Math::GMP::powm_gmp", XS_Math__GMP_powm_gmp, file, "$$$");
        (void)newXSproto_portable("Math::GMP::mmod_gmp", XS_Math__GMP_mmod_gmp, file, "$$");
        (void)newXSproto_portable("Math::GMP::mod_2exp_gmp", XS_Math__GMP_mod_2exp_gmp, file, "$$");
        (void)newXSproto_portable("Math::GMP::op_stringify", XS_Math__GMP_op_stringify, file, "$$$");
        (void)newXSproto_portable("Math::GMP::op_numify", XS_Math__GMP_op_numify, file, "$$$");
        (void)newXSproto_portable("Math::GMP::op_bool", XS_Math__GMP_op_bool, file, "$$$");
        (void)newXSproto_portable("Math::GMP::op_add", XS_Math__GMP_op_add, file, "$$$");
        (void)newXSproto_portable("Math::GMP::op_sub", XS_Math__GMP_op_sub, file, "$$$");
        (void)newXSproto_portable("Math::GMP::op_mul", XS_Math__GMP_op_mul, file, "$$$");
        (void)newXSproto_portable("Math::GMP::bmulf", XS_Math__GMP_bmulf, file, "$$");
        (void)newXSproto_portable("Math::GMP::op_div", XS_Math__GMP_op_div, file, "$$$");
        (void)newXSproto_portable("Math::GMP::bdiv", XS_Math__GMP_bdiv, file, "$$");
        (void)newXSproto_portable("Math::GMP::op_mod", XS_Math__GMP_op_mod, file, "$$$");
        (void)newXSproto_portable("Math::GMP::bmodinv", XS_Math__GMP_bmodinv, file, "$$");
        (void)newXSproto_portable("Math::GMP::op_spaceship", XS_Math__GMP_op_spaceship, file, "$$$");
        (void)newXSproto_portable("Math::GMP::op_eq", XS_Math__GMP_op_eq, file, "$$$");
        (void)newXSproto_portable("Math::GMP::legendre", XS_Math__GMP_legendre, file, "$$");
        (void)newXSproto_portable("Math::GMP::jacobi", XS_Math__GMP_jacobi, file, "$$");
        (void)newXSproto_portable("Math::GMP::probab_prime", XS_Math__GMP_probab_prime, file, "$$");
        (void)newXSproto_portable("Math::GMP::op_pow", XS_Math__GMP_op_pow, file, "$$");
        (void)newXSproto_portable("Math::GMP::bgcd", XS_Math__GMP_bgcd, file, "$$");
        (void)newXSproto_portable("Math::GMP::blcm", XS_Math__GMP_blcm, file, "$$");
        (void)newXSproto_portable("Math::GMP::fibonacci", XS_Math__GMP_fibonacci, file, "$");
        (void)newXSproto_portable("Math::GMP::band", XS_Math__GMP_band, file, "$$;@");
        (void)newXSproto_portable("Math::GMP::bxor", XS_Math__GMP_bxor, file, "$$;@");
        (void)newXSproto_portable("Math::GMP::bior", XS_Math__GMP_bior, file, "$$;@");
        (void)newXSproto_portable("Math::GMP::blshift", XS_Math__GMP_blshift, file, "$$$");
        (void)newXSproto_portable("Math::GMP::brshift", XS_Math__GMP_brshift, file, "$$$");
        (void)newXSproto_portable("Math::GMP::bfac", XS_Math__GMP_bfac, file, "$");
        (void)newXSproto_portable("Math::GMP::bnok", XS_Math__GMP_bnok, file, "$$");
        (void)newXSproto_portable("Math::GMP::gmp_copy", XS_Math__GMP_gmp_copy, file, "$");
        (void)newXSproto_portable("Math::GMP::gmp_tstbit", XS_Math__GMP_gmp_tstbit, file, "$$");
        (void)newXSproto_portable("Math::GMP::broot", XS_Math__GMP_broot, file, "$$");
        (void)newXSproto_portable("Math::GMP::brootrem", XS_Math__GMP_brootrem, file, "$$");
        (void)newXSproto_portable("Math::GMP::bsqrt", XS_Math__GMP_bsqrt, file, "$");
        (void)newXSproto_portable("Math::GMP::bsqrtrem", XS_Math__GMP_bsqrtrem, file, "$");
        (void)newXSproto_portable("Math::GMP::is_perfect_power", XS_Math__GMP_is_perfect_power, file, "$");
        (void)newXSproto_portable("Math::GMP::is_perfect_square", XS_Math__GMP_is_perfect_square, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
